 ;Eintrge in 'rsx'-Sprungtabelle

 jp winin
 jp winot
 jp wdraw
 jp wopen
 jp wclose
 jp shadon
 jp shadof

 ;Eintrge  'table' der RSX-Befehle

 defm "WINDOW.I"
 defb "N"+#80
 defm "WINDOW.OU"
 defb "T"+#80
 defm "WINDOW.DRA"
 defb "W"+#80
 defm "WINDOW.OPE"
 defb "N"+#80
 defm "WINDOW.CLOS"
 defb "E"+#80
 defm "SHADOW.O"
 defb "N"+#80
 defm "SHADOW.OF"
 defb "F"+#80

;Assemblerlisting d. Befehlsroutinen

winin: cp 6            ;6 Parameter?
 jp m,opmis
 jp nz,imparg
 push ix       ;Parameteradr. retten
 inc ix    ;2 Parameter berspringen
 inc ix         ;(Adresse und Lnge)
 inc ix
 inc ix
 dec a           ;Parameteranzahl -2
 dec a
 call wini     ;Hintergrund einlesen
 pop ix         ;Parameteradr. holen
 ld hl,(wlaeng)       ;Lnge nach HL
 ld e,(ix+0);Adr.des Lngepa.nach DE
 ld d,(ix+1)
 ex de,hl
 ld (hl),e    ;und Lnge zurckgeben
 inc hl
 ld (hl),d
 ld hl,(wadr);Das selbe mit der Adr.
 ld e,(ix+2)
 ld d,(ix+3)
 ex de,hl
 ld (hl),e
 inc hl
 ld (hl),d
 ret                    ;und fertig!

wini: cp 4             ;4 Parameter?
 jp m,opmis
 jp nz,imparg
 ld a,(ix+4)          ;Y-Wert nach A
 ld b,(ix+0)         ;Y-Lnge nach B
 add a,b               ;Summe nach A
 dec a ;-1
 jp m,imparg        ;<0? dann Fehler
 cp 25              ;<25?
 jp p,imparg           ;sonst Fehler
 ld a,(ix+6)          ;X-Wert nach A
 ld b,(ix+2)          ;XLnge nach B
 add a,b               ;Summe nach A
 dec a ;-1
 jp m,imparg        ;<0? dann Fehler
 ld b,a               ;X-Wert nach B
 ld a,(smode);Bildschirmmodus nach A
 ld c,10 ;Breite von Mode 0(Zeichen)
                     ;durch 2 nach c
 inc a           ;Bildschirmmodus +1
wini0: sla c                  ;C=C*2
 dec a                        ;A=A-1
 jp nz,wini0               ;bis A=0,
         ;dann Breite (Zeichen) in C
 dec c                    ;Breite -1
 ld a,c                      ;nach A
 cp b               ;X-Wert >Breite?
 jp m,imparg            ;dann Fehler
 ld b,(ix+0)         ;y-Lnge nach B
 ld l,(ix+2)        ;X-Lnge nach HL
 ld h,0
 ld a,(smode)       ;Bildschirmmodus
 ld e,a                      ;nach E
 ld a,2                   ;und von 2
 sub e                     ;abziehen
 ld d,a                  ;und nach D
 ld a,l                ;Xdiff nach A
 jp z,wini1    ;wenn Modus=2: weiter
 sla a            ;sonst Xdiff mal 2
 dec d                     ;Modus=1?
 jp z,wini1             ;dann weiter
 sla a    ;sonst nochmal Xdiff mal 2
wini1: ld l,a  ;Xdiff wieder nach HL
 sla b                  ;Ydiff mal 8
 sla b
 sla b
 push hl               ;Xdiff retten
 push bc               ;Ydiff retten
 push hl              ;Xdiff nach DE
 pop de              ;HL jetzt Lnge
 dec b                     ;Ydiff -1
wini2: add hl,de  ;Lnge=Lnge+Xdiff
 djnz wini2           ;bis Ydiff-1=0
 ld (wlaeng),hl ;und Lnge speichern
 ex de,hl             ;Lnge nach DE
 ld hl,(himem) ;Himem-Zeiger nach HL
 sbc hl,de     ;um Lnge verkleinern
 push hl   ;und neuer Zeiger nach DE
 pop de
 push hl          ;und Zeiger retten
 call getmem   ;Speicher reservieren
 pop hl                ;Zeiger holen
 ld (wadr),hl;Himem Zeiger speichern
 push hl                 ;und retten
 ld l,(ix+4)          ;Y-Wert nach L
 ld h,(ix+6)          ;X-Wert nach H
 call #bc1a       ;SCR CHAR POSITION
 pop de        ;Himem-Zeiger nach DE
 pop bc                 ;Ydiff holen
 ld a,b                ;Ydiff nach A
 pop bc                 ;Xdiff holen
wini3: push hl      ;Bildadr. retten
 push bc              ;Zhler retten
 ldir    ;Xdiff Bytes aus Bildschirm
                ;in Buffer schreiben
 pop bc                ;Zhler holen
 pop hl              ;Bildadr. holen
 push af               ;Ydiff retten
 call #bc26           ;SCR NEXT LINE
 pop af                 ;Ydiff holen
 dec a                     ;Ydiff -1
 jp nz,wini3     ;weiter bis Ydiff=0
 ret                        ;fertig!

wlaeng:defs 2       ;Lnge d.Windows
                        ;im Speicher
wadr: defs 2        ;Adr. d. Windows
                        ;im Speicher

getmem:
 rst #18            ;FAR CALL (RST3)
 defw shimem   ;Zeiger auf SET HIMEM
 rst #18                   ;FAR CALL
 defw buffre        ;I/O-Buffer ggr.
                          ;freigeben
 ld (himem),hl;Him-Zeiger neu setzen
         ;CPC 464:hier INC HL einfg.
 ret                     ;und zurck

shimem:defw #f808   ;Adr. SET HIMEM
                         ;(464:F750)
 defb #fd                ;ROM-Select

buffre:defw #f761    ;Adr.I/O Buffer
                          ;ggf.freig.
                         ;(464:f675)
 defb #fd

himem: equ #ae5e           ;464:ae7b


winot:               ;schreibt einen
              ;Bildausschnitt zurck
 cp 6                  ;6 Parameter?
 jp m,opmis
 jp nz,imparg
 ld l,(ix+0)                  ;Lnge
 ld h,(ix+1)
 ld (wlaeng),hl
 ld l,(ix+2)            ;und Adresse
 ld h,(ix+3)
 ld (wadr),hl             ;speichern
 inc ix    ;2 Parameter berspringen
 inc ix
 inc ix
 inc ix
 dec a
 dec a

wino:       ;schreibt Bildausschnitt
 cp 4                  ;4 Parameter?
 jp m,opmis
 jp nz,imparg
 ld a,(ix+0)   ;Parameter berprfen
 ld b,(ix+4)         ;(wie bei WINI)
 add a,b
 dec a
 jp m,imparg
 cp 25
 jp p,imparg
 ld a,(ix+2)
 ld b,(ix+6)
 add a,b
 dec a
 jp m,imparg
 ld b,a
 ld a,(smode)
 ld c,10
 inc a
wino0: sla c
 dec a
 jp nz,wino0
 dec c
 ld a,c
 cp b
 jp m,imparg
 ld b,(ix+0)              ;Ydiff und
 ld l,(ix+2)        ;Xdiff berechnen
 ld h,0 ;(wie WINI)
 ld a,(smode)
 ld e,a
 ld a,2
 sub e
 ld d,a
 ld a,l
 jp z,wino1
 sla a
 dec d
 jp z,wino1
 sla a
wino1: ld l,a
 sla b
 sla b
 sla b
 push hl                  ;Xdiff und
 push bc               ;Ydiff retten
 ld l,(ix+4)      ;Koordinaten holen
 ld h,(ix+6)
 call #bc1a       ;SCR CHAR POSITION
 pop bc                 ;Ydiff holen
 ld a,b                  ;und nach A
 pop bc               ;Xdiff nach BC
 ex de,hl          ;Bildadr. nach DE
 ld hl,(wadr)    ;Bufferadr. nach HL
wino3: push de      ;Bildadr. retten
 push bc              ;Zhler retten
 ldir    ;Xdiff Bytes aus Bildschirm
                ;in Buffer schreiben
 pop bc                ;Zhler holen
 pop de              ;Bildadr. holen
 ex de,hl          ;Bildadr. nach HL
 push af               ;Ydiff retten
 call #bc26           ;SCR NEXT LINE
 pop af                 ;Ydiff holen
 ex de,hl   ;Bildadr. wieder nach DE
 dec a                     ;Ydiff -1
 jp nz,wino3     ;weiter bis Ydiff=0

memfre:   ;gibt Speicher wieder frei
 rst #18
 defw buffre ;I/O-Buffer ggf. freig.
 memfr0:ld hl,(himem)  ;Himem-Zeiger
 ex de,hl                   ;nach DE
   ;464: INC DE
 ld hl,(wadr);Zeiger auf freien Ber.
  sbc hl,de ;Zeiger unterhalb Himem?
 jp m,newmem         ;dann freigeben
 jp z,newmem     ;=Himem? freigeben!
 ld de,(wadr) ;Anf. des Ber. nach HL

memfr3:ld a,(#b735)      ;Symboltab.
                        ;(464: B295)
 or a                  ;im Speicher?
 ret z        ;nein? dann war's nix!
 ld a,(#b734)   ;Nr.d.1.Symb. nach C
   ;464: B294
 ld c,a
 xor a                 ;Akku lschen
 ld b,a                   ;B lschen
 sub c   ;A=256-C (=Anz. d. Symbols)
 ld c,a                      ;nach C
 sla c      ;Lnge der Symboltabelle
 rl b    ;(=8*Anz.d.Symbols) nach BC
 sla c
 rl b
 sla c
 rl b
 ld hl,(#b736)     ;Adr.d.Symboltab.
                  ;nach HL 464: B296
 add hl,bc     ;Adr.hinter Symb.tab.
                            ;nach HL
 sbc hl,de       ;=Adr. d. Bereichs?
 ret nz           ;Nein? wieder nix!
 ld hl,(wlaeng)      ;sonst Lnge d.
                  ;Bereichs nach HL,
 ld de,(wadr)  ;Bereichsadr. nach DE
 add hl,de        ;HL hinter Bereich
 dec de         ;DE auf Tabellenende
 dec hl         ;HL auf Bereichsende
 ex de,hl        ;DE und HL tauschen
 lddr        ;Symboltabelle kopieren
 inc de         ;DE auf Bereichsende
 inc hl        ;HL auf Symboltabelle
 ld (wadr),hl;Bereichsende eintragen
 ld (#b736),de ;Symboladr. eintragen
                          ;464: B296
 jp memfr0       ;und nochmal testen

newmem:ld hl,(wlaeng)    ;Lnge nach
 ex de,hl                        ;DE
 ld hl,(wadr)          ;Adr. nach HL
 add hl,de         ;neues Himem nach
 push hl                  ;DE und HL
 pop de      ;CPC 464: DEC DE einfg.
 jp getmem               ;und setzen

winadr:defs 18  ;Adresse der Windows
winlan:defs 18    ;Lnge der Windows
wincnt:defs 1    ;Anzahl der Windows
winx1: defs 9 ;Anfangss. der Windows
winx2: defs 9 ;Endspalte der Windows
winy1: defs 9 ;Anfangsz. der Windows
winy2: defs 9 ;Endzeile  der Windows
winnum:defs 9          ;Windownummer
hidden:defs 9 ;Tabelle fr verst. Ws
koobuf:defs 4  ;Graphikcursorkoords.
ubgbuf:defs 12 ;Buffer fr Parameter


wdraw:              ;Window zeichnen
 cp 4                  ;4 Parameter?
 jp m,opmis
 jp nz,imparg
 ld hl,v1  ;HL auf Cursorkoordinaten
 ld de,koobuf  ;DE auf Koordi.buffer
 ld bc,4                     ;4 Byte
 ldir                      ;kopieren
 ld h,(ix+6)    ;Koordinaten nach HL
 ld l,(ix+4)
 ld d,(ix+2)         ;Lngen nach DE
 ld e,(ix+0)
wdraw1:push hl   ;Koordinaten retten
 push de              ;Lngen retten
 ld a,h              ;Xanfang nach A
 add a,d                     ;+Xdiff
 dec a                           ;-1
 ld d,a                      ;=Xende
 ld a,l              ;Yanfang nach A
 add a,e                     ;+Ydiff
 dec a                           ;-1
 ld e,a                      ;=Xende
 push hl         ;Anf.koords. retten
 push de          ;Endkoords. retten
 ld a,0           ;0-Byte zum Fllen
 call #bc44            ;SCR FILL BOX
 pop de            ;Endkoords. holen
 pop hl        ;Anfangskoords. holen
 push hl          ;und wieder retten
 push de
 ld a,l                 ;Yanf nach A
 cp e                        ;-Yende
 jp z,wdrnex    ;gleich? dann weiter
 dec h                       ;Xanf-1
 inc l                       ;Yanf+1
 ld d,h                  ;Xende=Xanf
 call shadow ;seitl. Schatten darst.
wdrnex:pop de          ;Koords holen
 pop hl
 ld a,h                 ;Xanf nach A
 cp d                       ;=Xende?
 jp z,wdrnx1            ;dann weiter
 dec h                       ;Xanf-1
 inc e                      ;Yende+1
 ld l,e                  ;Yanf=Yende
 dec d                     ;Xendne-1
 call shadow   ;unt. Schatten darst.
wdrnx1:call #bc1a ;SCR CHAR POSITION
 pop de                ;Lngen holen
 pop hl               ;Koords. holen
 push de              ;Lngen retten
 ld e,h                ;Xanf nach DE
 ld d,0
 ld h,0                ;Yanf nach HL
 add hl,hl                  ;Yanf*16
 add hl,hl
 add hl,hl
 add hl,hl
 ex de,hl              ;Xanf nach HL
 add hl,hl                   ;Xanf*8
 add hl,hl
 add hl,hl
 dec b               ;Zeichengre-1
 jp z,wdrnx2        ;=0? dann weiter
 add hl,hl             ;sonst Xanf*2
 dec b               ;Zeichengre-1
 jp z,wdrnx2        ;=0? dann weiter
 add hl,hl     ;sonst nochmal Xanf*2
wdrnx2:ex de,hl ;Xanf wieder nach DE
 dec de                      ;Xanf-1
 push hl               ;Yanf nach BC
 pop bc
 ld hl,400                   ;HL=400
 sbc hl,bc    ;Yanf=400-Yanf (0-399)
 call #bbc0       ;GRA MOVE ABSOLUTE
 ld a,1                         ;A=1
 call #bbde             ;GRA SET PEN
 call #bc1a       ;SCR CHAR POSITION
 pop de                ;Lngen holen
 ld l,e               ;Ydiff nach HL
 ld e,d               ;Xdiff nach DE
 ld d,0
 ld h,0
 add hl,hl                 ;Ydiff*16
 add hl,hl
 add hl,hl
 add hl,hl
 ex de,hl             ;Xdiff nach HL
 add hl,hl                  ;Xdiff*8
 add hl,hl
 add hl,hl
 dec b               ;Zeichengre-1
 jp z,wdrnx3        ;=0? dann weiter
 add hl,hl                  ;Xdiff*2
 dec b               ;Zeichengre-1
 jp z,wdrnx3                    ;=0?
 add hl,hl                  ;Xdiff*2
wdrnx3:ex de,hl       ;Xdiff nach DE
 inc de                     ;Xdiff+2
 inc hl                     ;Ydiff+2
 inc de
 inc hl
 push de               ;Xdiff retten
 push hl               ;Ydiff retten
 ld hl,0                    ;Ydiff=0
 call #bbf9       ;GRA LINE RELATIVE
 pop hl                 ;Ydiff holen
 pop de                 ;Xdiff holen
 push hl               ;Ydiff retten
 push de               ;Xdiff retten
 ld de,0                    ;Xdiff=0
 ld a,h           ;Ydiff_high nach A
 xor #ff                       ;A=-A
 ld h,a      ;Ydiff_high=-Ydiff_high
 ld a,l            ;Ydiff_low nach A
 xor #ff          ;Vorzeichenwechsel
 ld l,a                ;Ydiff=-Ydiff
 inc hl               ;Ydiff=Ydiff+1
 call #bbf9       ;GRA LINE RELATIVE
 pop de                 ;Xdiff holen
 ld a,d                ;Xdiff=-Xdiff
 xor #ff
 ld d,a
 ld a,e
 xor #ff
 ld e,a
 ld hl,0                    ;Ydiff=0
 call #bbf9       ;GRA LINE RELATIVE
 pop hl                 ;Ydiff holen
 ld de,0                    ;Xdiff=0
 call #bbf9       ;GRA LINE RELATIVE
 ld hl,koobuf           ;Koordinaten
 ld de,v1                ;aus Buffer
 ld bc,4             ;zurckkopieren
 ldir
 ret                        ;fertig!

shadow:           ;Schatten zeichnen
 nop                    ;Shadow-Flag
 push hl     ;Anfangs-Koords. retten
 call #bc1a       ;SCR CHAR POSITION
 pop hl       ;Anfangs-Koords. holen
 ld a,d                ;Xende nach A
 sub h                        ;-Xanf
 inc a                           ;+1
 dec b               ;Zeichengre-1
 jp z,sham2         ;=0? dann Mode 2
 sla a                ;sonst Xdiff*2
 dec b               ;Zeichengre-1
 jp z,sham1         ;=0? dann weiter
 sla a                ;sonst Xdiff*2
sham1: ld d,a          ;Xdiff nach D
 ld a,e                ;Ydiff nach A
 sub l
 inc a
 sla a                      ;Ydiff*8
 sla a
 sla a
 ld e,a                ;Ydiff nach E
 call #bc1a       ;SCR CHAR POSITION
shad1: push hl      ;Bildadr. retten
 push de              ;Lngen retten
sha1: push de ;Lngen nochmal retten
 ld d,#11  ;Punktmaske Mode 1 nach D
 ld c,1      ;Farbmaske PEN 2 nach C
 ld b,#10    ;Farbmaske PEN 1 nach B
 ld e,0      ;E lschen (neues Byte)
sha0: ld a,(hl) ;Byte aus Bild lesen
 and d           ;Punkt ausmaskieren
 jp nz,sha2   ;Punkt gesetzt? weiter
 push af                ;Byte retten
 ld a,e           ;neues Byte nach A
 or c            ;PEN 2 einmaskieren
 ld e,a           ;und wieder nach E
 pop af           ;Byte wieder holen
 jp sha3            ;weiter bei SHA3
sha2: push af           ;Byte retten
 ld a,e           ;neues Byte nach A
 or b            ;PEN 1 einmaskieren
 ld e,a               ;wieder nach E
 pop af           ;Byte wieder holen
sha3: sla c     ;Masken auf n. Punkt
 sla b
 sla d
 jp nc,sha0 ;kein bertrag v. Maske?
           ;dann nchsten Pkt bearb.
 ld (hl),e     ;neues Byte schreiben
 pop de                ;Lngen holen
 inc hl                ;Adr. erhhen
 dec d                      ;Xdiff-1
 jp nz,sha1   ;<>0?  Adr. bearbeiten
 pop de                ;Lngen holen
 pop hl                  ;Adr. holen
 call #bc26           ;SCR NEXT LINE
 dec e                      ;Ydiff-1
 jp nz,shad1      ;bearbeiten bis =0
 ret                        ;fertig!

sham2:          ;Schatten fr Mode 2
 ld d,a                ;Xdiff nach D
 ld a,e                ;Yende nach A
 sub l                        ;-Yanf
 inc a                           ;+1
 sla a                      ;Ydiff*8
 sla a
 sla a
 ld e,a                ;Ydiff nach E
 call #bc1a       ;SCR CHAR POSITION
sham2a:push hl      ;Bildadr. retten
 push de              ;Lngen retten
sham2b:ld a,(hl)  ;Byte aus Speicher
 xor #ff           ;Byte invertieren
 ld (hl),a     ;Byte zurckschreiben
 inc hl                ;Adr. erhhen
 dec d                      ;Xdiff-1
 jp nz,sham2b         ;weiter bis =0
 pop de                ;Lngen holen
 pop hl                  ;Adr. holen
 call #bc26           ;SCR NEXT LINE
 dec e                      ;Ydiff-1
 jp nz,sham2a         ;weiter bis =0
 ret                         ;fertig

shadon:       ;schaltet Schatten ein
 ld a,0            ;NOP-Byte in Akku
 ld (shadow),a ;in Schadowflag schr.
 ret                        ;fertig!

shadof:       ;schaltet Schatten aus
 ld a,#c9               ;RET in Akku
 ld (shadow),a ;in Schadowflag schr.
 ret                        ;fertig!



wopen:          ;Erffnet ein Window
 cp 5                  ;5 Parameter?
 jp m,opmis
 jp nz,imparg
 ld a,(wincnt)  ;Windowzhler nach A
 cp 8              ;schon 8 Windows?
 jp z,imparg            ;dann Fehler
 ld b,(ix+8)    ;Windownummer nach B
 ld a,8              ;max. 8 Windows
 cp b
 jp m,imparg           ;sonst Fehler
 ld c,0       ;mit Window 0 tauschen
 call #bbb7        ;TXT SWAP STREAMS
 ld h,(ix+6) ;Anfangskoords. nach HL
 ld l,(ix+4)
 ld d,(ix+2)     ;Endkoords. nach DE
 ld e,(ix+0)
 push ix
 push hl
 push de
 dec h             ;Anfangskoords.-1
 dec l
 push hl         ;Koordinaten retten
 push de
 dec d                  ;Endkoords-1
 dec e
 call #bb66          ;TXT WIN ENABLE
 ld b,(ix+8)       ;Windownr. nach B
 ld c,0 ;wieder mit 0 zurcktauschen
 call #bbb7        ;TXT SWAP STREAMS
 ld ix,ubgbuf ;IX auf bergabebuffer
 pop de             ;Endkoords holen
 pop hl         ;Anfangskoords holen
 dec h              ;Anfangskoords-1
 dec l
 ld a,d ;Endkoords in Lngen wandeln
 sub h
 ld d,a
 ld a,e
 sub l
 ld e,a
 inc d                    ;Lngen +1
 inc e
 ld (ix+0),e  ;Koords. und Lngen in
 ld (ix+2),d   ;bergabebuffer schr.
 ld (ix+4),l
 ld (ix+6),h
 ld a,4                 ;4 Parameter
 call wini       ;Hintergrund retten
 ld hl,winadr  ;HL auf Adresstabelle
 ld a,(wincnt)  ;Windowzhler nach A
 inc a         ;Windowzhler erhhen
 ld (wincnt),a  ;und zurckschreiben
 ld c,a              ;Zhler nach BC
 ld b,0
 add hl,bc  ;Zhler 2x auf Tab. add.
 add hl,bc
 ld de,(wadr)    ;Windowadr. nach DE
 ld (hl),e ;W.adr. in Tab. eintragen
 inc hl
 ld (hl),d
 ld hl,winlan  ;HL auf Lngentabelle
 add hl,bc   ;HL auf Pos. d. Windows
 add hl,bc
 ld de,(wlaeng) ;Windowlnge nach DE
 ld (hl),e  ;Windowl. in Tab. eintr.
 inc hl
 ld (hl),d
 push bc        ;Windowzhler retten
 inc (ix+6)       ;Anfangskoords. +1
 inc (ix+4)
 dec (ix+2)               ;Lngen -2
 dec (ix+2)
 dec (ix+0)
 dec (ix+0)
 ld a,4                 ;4 Parameter
 call wdraw         ;Window zeichnen
 pop bc          ;Windowzhler holen
 pop de            ;Endkoords. holen
 ld hl,winx2   ;HL auf Xende-Tabelle
 add hl,bc          ;Zhler addieren
 ld (hl),d          ;Xende eintragen
 ld hl,winy2   ;HL auf Yende-Tabelle
 add hl,bc          ;Zhler addieren
 ld (hl),e          ;Yende eintragen
 pop de        ;Anfangskoords. holen
 ld hl,winx1   ;HL auf Xanf.-Tabelle
 add hl,de          ;Zhler addieren
 ld (hl),d          ;Xanf. eintragen
 ld hl,winy1   ;HL auf Yanf.-Tabelle
 ld (hl),e          ;Yanf. eintragen
 pop ix             ;Parameter holen
 ld a,(ix+8)       ;Windownr. nach A
 ld hl,winnum;HL auf Tab. d. Win.nr.
 add hl,bc          ;Zhler addieren
 ld (hl),a      ;Windownr. eintragen
 ret                        ;fertig!


wclose:         ;schliet ein Window
 ld a,(wincnt)         ;Windowzhler
 or a ;=0?
 jp z,imparg            ;dann Fehler
wclo2: ld c,a        ;Zhler nach BC
 ld b,0
 ld ix,ubgbuf         ;IX auf Buffer
 ld hl,winx1       ;HL auf Xanf-Tab.
 add hl,bc              ;HL auf Xanf
 ld d,(hl)              ;Xanf nach D
 dec d                       ;Xanf-2
 dec d
 ld (ix+6),d              ;bergeben
 ld hl,winx2      ;HL auf Xende-Tab.
 add hl,bc             ;HL auf Xende
 ld a,(hl)             ;Xende nach A
 inc a                      ;Xende+1
 sub d                 ;Xdiff nach A
 ld (ix+2),a              ;bergeben
 ld hl,winy1  ;Y-Werte bergeben wie
 add hl,bc                  ;X-Werte
 ld d,(hl)
 dec d
 dec d
 ld (ix+4),d
 ld hl,winy2
 add hl,bc
 ld a,(hl)
 inc a
 sub d
 ld (ix+0),a
 ld hl,winadr     ;HL auf Adresstab.
 add hl,bc           ;HL auf Adresse
 add hl,bc
 ld e,(hl)          ;Adresse nach DE
 inc hl
 ld d,(hl)
 ld (wadr),de     ;Adresse bergeben
 ld hl,winlan        ;Lnge wie Adr.
 add hl,bc
 add hl,bc
 ld e,(hl)
 inc hl
 ld d,(hl)
 ld (wlaeng),de
 ld a,4                 ;4 Parameter
 call wino        ;Window ausblenden
 ld a,(wincnt)  ;Windowzhler nach A
 dec a ;-1
 ld (wincnt),a  ;und zurckschreiben
 ret                        ;fertig!


