;       *****************************************
;       CEUS - Cpc Extended User System - Toolbox
;       1989 by Joerg Schwieder
;       *****************************************

        org     #8000           ;Anfangsadresse setzen
logext:equ      #bcd1           ;KL LOG EXT
extern:ld       bc,rsx          ;Adresse der RSX-Sprungtabelle in bc
        ld      hl,kernel       ;4 Byte fr Kernel in HL
        call    logext          ;KL LOG EXT
        ld      a,#c9           ;RET in Akku laden
        ld      (extern),a      ;RET in EXTERN schreiben
        ret                     ;und zurck
kernel:defs     4               ;4 Bytes fr Kernel freihalten
rsx:    defw    table           ;Zeiger auf Befehlstabelle
                                 Hier kommen die Sprungbefehle hin
table:                          ;Befehlstabelle
                                 Hier kommen die Befehle hin
        defb    0               ;Hiermit wird die Liste abgeschlossen


memful:                 ;Routine fuer 'Memory full'
        ld      a,7             ;Fehlercode in Akku
        ld      e,7             ;und e
        jp      errmsg          ;Fehlermeldung ausgeben

imparg:                 ;Routine fuer 'Improper argument'
        ld      a,5             ;Fehlercode in Akku
        ld      e,5             ;und e
        jp      errmsg          ;Fehlermeldung Ausgeben

opmis:                          ;Routine fuer 'Operand missing'
        ld      a,22            ;Fehlercode in Akku
        ld      e,22            ;und e

errmsg:                 ;Fehlermeldung Ausgeben
        rst     #18             ;FAR CALL (RST3)
        defw    errjmp          ;Zeiger auf Adresse der Fehlerroutine
        ret                     ;und zurueck

errjmp:defw     #cb55           ;Adresse der Fehlerbehandlungsroutine
                                 des Betriebssystems (464:ca94 664:cb58)
        defb    #fd             ;ROM-Select


