; Eintrge in 'rsx'-Sprungtabelle

 jp whide
 jp wshow
 jp winpop
 jp wname


; Eintrge in 'table' der RSX-Befehle

 defm "WINDOW.HID"
 defb "E"+#80
 defm "WINDOW.SHO"
 defb "W"+#80
 defm "WINDOW.PO"
 defb "P"+#80
 defm "WINDOW.NAM"
 defb "E"+#80


; Assemblerlisting zu den Befehlen

wname:   ;W. ffnen u. Namen geben
 cp 6 ;6 Parameter?
 jp m,opmis
 jp nz,imparg
 ld l,(ix+0);Stringdeskr.adr. nach HL
 ld h,(ix+1)
 ld a,(ix+4);Xende nach A
 ld d,(ix+8);Xanf nach D
 sub d ;Xdiff nach A
 inc a
 cp (hl) ;String lnger als Xdiff?
 jp m,imparg;dann Fehler
 push hl ;Deskr.adr. retten
 push ix ;Parameter retten
 inc ix ;String berspringen
 inc ix
 dec (ix+4) ;Obergrenze 2 nach oben
 dec (ix+4) ;(Platz fr berschrift)
 ld a,5 ;Parameter-1
 call wopen ;Window ffnen
 pop ix ;Parameter holen
 ld a,(ix+10);Nummer des Fensters
 call #bbb4 ;als aktuelles Fenster
 push af ;altes Fenster
 pop hl ;nach HL
 ex (sp),hl ;und mit Deskr. tauschen
 ld a,(ix+4);Xende nach A
 ld b,(ix+8);Xanf nach B
 sub b ;Xdiff nach A
 inc a
 ld b,(hl) ;Stringlnge nach B
 sub b ;Differenz nach A
 srl a ;Differenz/2...
 ld b,32 ;...Spaces...
 call nz,chars;...ausgeben
 ld a,(hl) ;Stringlnge nach A
 inc hl ;HL auf String
 call print ;String ausgeben
 ld hl,#0102;Cursorposition 1/2
 call #bb75 ;TXT SET CURSOR
 ld a,(ix+4);Xende nach A
 ld b,(ix+8);Xanf nach B
 sub b ;Xdiff nach A
 inc a
 ld b,154 ;Linie
 call chars ;ausgeben
 ld h,(ix+8);Koordinaten d. W. nach
 dec h ;HL und DE (physikalisch)
 ld l,(ix+6)
 inc l ;Obergrenze korrigieren
 ld d,(ix+4)
 dec d
 ld e,(ix+2)
 dec e
 call #bb66 ;TXT WIN ENABLE
 pop af ;alte W.nummer wieder holen
 jp #bbb4 ;TXT STR SELECT

chars: push bc ;BC retten
 ld c,a ;Zhler nach C
 ld a,b ;Zeichen nach A
 ld b,c ;Zhler nach B
char1: call #bb5a ;TXT WR CHAR
 djnz char1 ;weiter bis Zhler=0
 pop bc ;BC holen
 ret  ;und zurck

print: ld b,a ;Lnge nach B
 ld e,(hl) ;Stringadr. nach DE
 inc hl
 ld d,(hl)
 ex de,hl ;Stringadr nach HL
prin1: ld a,(hl) ;Zeichen aus String
 call #bb5a ;TXT WR CHAR
 inc hl ;HL auf nchstes Zeichen
 djnz prin1 ;weiter bis Lnge=0
 ret  ;und zurck


whide:   ;'Versteckt' ein Window
 cp 1 ;1 Parameter?
 jp m,opmis
 jp nz,imparg
 ld a,(wincnt);Anzahl der Windows
 or a ;=0?
 jp z,imparg;dann Fehler
 ld b,a ;Anzahl nach B
 ld hl,winnum;HL auf Nummern
 ld a,(ix+0);Nummer als Param. holen
whd1: inc hl ;HL auf nchsten Eintrag
 cp (hl) ;=Param.?
 jp z,whd2 ;dann weiter
 djnz whd1 ;sonst nchster Eintrag
 jp imparg ;nicht da? Fehler!
whd2: ld a,(wincnt);MaxWin+1
 sub b ;-Tabellennummer
 inc a
 ld c,a ;=Offset fr Eintrag
 ld b,0 ;nach BC
 ld hl,hidden;HL auf Eintrag in der
 add hl,bc ;Vertsteckt-Tabelle
 ld a,(hl) ;Eintrag holen
 cp #ff ;Window schon versteckt?
 ret z ;dann zurck
 ld hl,winx1;HL auf Xanf
 add hl,bc
 ld d,(hl) ;Xanf nach D
 dec d ;Xanf-2
 dec d
 ld hl,winy1;HL auf Yanf
 add hl,bc
 ld e,(hl) ;Yanf nach E
 dec e ;Yanf-2
 dec e
 push bc ;Offset retten
 push bc
 ex de,hl ;Koords. nach HL
 call #bc1a ;Adr. von links oben..
 ex de,hl ;...nach DE
 pop bc ;Offset holen
 push de ;Windowadr. retten
 ld hl,winadr;HL auf Hintergrundadr.
 add hl,bc
 add hl,bc
 ld e,(hl) ;Hintergrundadr. nach DE
 inc hl
 ld d,(hl)
 push de ;H.adr. retten
 ld hl,winx2;HL auf Xende
 add hl,bc
 ld a,(hl) ;Xende nach A
 ld hl,winx1;HL auf Xanf
 add hl,bc
 ld e,(hl) ;Xanf nach E
 sub e ;Xdiff
 inc a ;+3
 inc a
 inc a
 ld e,a ;nach E
 push bc ;Offset retten
 call #bc1a ;SCR CHAR POSITION
whd3: srl b ;Zeichenbreite /2
 jp c,whd4 ;bertrag? dann weiter
 sla e ;sonst Xdiff*2
 jp whd3 ;und nochmal
whd4: pop bc ;Offset holen
 ld hl,winy2;Ydiff nach D
 add hl,bc
 ld a,(hl)
 ld hl,winy1
 add hl,bc
 ld d,(hl)
 sub d
 inc a
 inc a
 inc a
 ld d,a
 sla d ;Ydiff*8
 sla d
 sla d
 push de ;Xdiff u. Ydiff
 pop bc ;nach BC
 pop de ;H.adr. nach DE
 pop hl ;W.adr. nach HL
whd5: push hl ;w.adr und
 push bc ;Diffs retten
whd6: ld a,(de) ;Hintergrundbyte nach A
 ldi  ;Byte a. Win. speichern
 dec hl ;HL wieder +1
 inc bc ;BC wieder +1
 ld (hl),a ;H.Byte wieder darst.
 inc hl ;nchstes Byte
 dec c
 jp nz,whd6 ;weiter bis Zeile dargest.
 pop bc ;Diffs holen
 pop hl ;HL holen
 call #bc26 ;nchste Zeile
 djnz whd5 ;nochmal bis alle Zeilen
 pop bc ;Offset holen
 ld hl,hidden;HL auf Hidden-Eintrag
 add hl,bc
 ld a,#ff ;'Versteckt'
 ld (hl),a ;setzen
 ret  ;Fertig!


wshow:   ;Blendet W. wieder ein
 cp 1 ;1 Parameter?
 jp m,opmis
 jp nz,imparg
 ld a,(wincnt)
 or a
 jp z,imparg
 ld b,a ;Anzahl nach B
 ld hl,winnum;HL auf Nummern
 ld a,(ix+0);Nummer als Param. holen
wsh1: inc hl ;HL auf nchsten Eintrag
 cp (hl) ;=Param.?
 jp z,wsh2 ;dann weiter
 djnz wsh1 ;sonst nchster Eintrag
 jp imparg ;nicht da? Fehler!
wsh2: ld a,(wincnt);MaxWin
 sub b ;-Tabellennummer
 inc a ;+1
 ld c,a ;=Offset fr Eintrag
 ld b,0 ;nach BC
 ld hl,hidden;HL auf Eintrag in der
 add hl,bc ;Vertsteckt-Tabelle
 ld a,(hl) ;Eintrag holen
 cp #ff ;Window versteckt?
 ret nz ;sonst zurck
 ld hl,winx1;HL auf Xanf
 add hl,bc
 ld d,(hl) ;Xanf nach D
 dec d ;Xanf-2
 dec d
 ld hl,winy1;HL auf Yanf
 add hl,bc
 ld e,(hl) ;Yanf nach E
 dec e ;Yanf-2
 dec e
 push bc ;Offset retten
 push bc
 ex de,hl ;DE und HL tauschen
 call #bc1a ;Adr. von links oben..
 ex de,hl ;...nach DE
 pop bc ;Offset holen
 push de ;Windowadr. retten
 ld hl,winadr;HL auf Hintergrundadr.
 add hl,bc
 add hl,bc
 ld e,(hl) ;Hintergrundadr. nach DE
 inc hl
 ld d,(hl)
 push de ;H.adr. retten
 ld hl,winx2;HL auf Xende
 add hl,bc
 ld a,(hl) ;Xende nach A
 ld hl,winx1;HL auf Xanf
 add hl,bc
 ld e,(hl) ;Xanf nach E
 sub e ;Xdiff
 inc a ;+3
 inc a
 inc a
 ld e,a ;nach E
 push bc ;Offset retten
 call #bc1a ;SCR CHAR POSITION
wsh3: srl b ;Zeichenbreite /2
 jp c,wsh4 ;bertrag? dann weiter
 sla e ;sonst Xdiff*2
 jp wsh3 ;und nochmal
wsh4: pop bc ;Offset holen
 ld hl,winy2;Ydiff nach D
 add hl,bc
 ld a,(hl)
 ld hl,winy1
 add hl,bc
 ld d,(hl)
 sub d
 inc a
 inc a
 inc a
 ld d,a
 sla d ;Ydiff*8
 sla d
 sla d
 push de ;Xdiff u. Ydiff
 pop bc ;nach BC
 pop de ;H.adr. nach DE
 pop hl ;W.adr. nach HL
 push bc ;Diffs retten
 push hl ;W.adr. retten
 call #bc1a ;SCR CHAR POSITION
 pop hl ;W.adr. holen
 ld a,b ;Zeichenbreite nach A
 pop bc ;Diffs holen
 push af ;Breite retten
wsh5: call getlne ;Zeilen lesen
 ld a,b ;Zeilenzhler-16
 sub 16
 ld b,a
wsh7: pop af ;Breite holen
 push af ;Breite wieder retten
 push hl ;W.adr. retten
 push bc ;Diffs retten
 call getchr ;linken Rand lesen
 call exclne ;W.Inhalt tauschen
 call getchr ;rechten Rand lesen
 pop bc ;Diffs holen
 pop hl ;W.adr holen
 call #bc26 ;nchste Zeile
 djnz wsh7 ;nochmal bis letzte
 pop af ;Breite holen
wsh9: call getlne ;Spalte lesen
 pop bc ;Offset holen
 ld hl,hidden;HL auf Hidden-Eintrag
 add hl,bc
 xor a ;'nicht Versteckt'
 ld (hl),a ;setzen
 ld hl,#bc44;HL auf SCR FILL BOX
 ld a,(hl) ;Byte nach A
 push af ;und retten
 ld (hl),#c9;und 'RET' einsetzen
 ld ix,ubgbuf;IX auf Buffer
 ld hl,winx1;HL auf Xanf
 add hl,bc
 ld a,(hl) ;Xanf-1 nach A
 dec a
 ld (ix+6),a;und in Buffer schreiben
 ld d,a ;Xanf nach D
 ld hl,winx2;HL auf Xende
 add hl,bc
 ld a,(hl) ;Xende nach A
 sub d ;Xdiff nach A
 ld (ix+2),a;Xdiff in Buffer schreiben
 ld hl,winy1;Y-Werte in Buffer
 add hl,bc
 ld a,(hl)
 dec a
 ld (ix+4),a
 ld d,a
 ld hl,winy2
 add hl,bc
 ld a,(hl)
 sub d
 ld (ix+0),a
 ld a,4 ;4 Parameter setzen
 call wdraw ;Fensterrahmen zeichnen
 pop af ;altes Byte holen
 ld hl,#bc44;und wieder nach
 ld (hl),a ;SCR FILL BOX schreiben
 ret  ;Fertig!

getlne:ld a,8 ;8 Zeilen
getln0:push bc ;Diffs retten
 push hl ;W.adr. retten
getln1:ld b,0 ;Breite nach BC
 LDIR  ;Zeile kopieren
 pop hl ;W.adr. holen
 pop bc ;Diffs holen
 push af ;Zhler retten
 call #bc26 ;nchste Zeile
 pop af ;Zhler holen
 dec a ;-1
 jp nz,getln0;weiter bis =0
 ret  ;und zurck

getchr:push af ;AF retten
getch1:ldi  ;1 Byte kopieren
 inc bc ;BC wieder restaurieren
 dec c ;Breite -2
 dec c
 dec a ;Zeichengre -1
 jp nz,getch1;und weiter bis ZG=0
 ret

exclne:Push af ;Zeichenbreite retten
excln1:ld a,(de) ;Byte aus Hintergr. nach A
 ldi  ;Byte aus Bild schreiben
 dec hl ;HL und BC wiederherstellen
 inc bc
 ld (hl),a ;Byte in Bildsch. schreiben
 inc hl ;nchstes Byte
 dec c ;Breite -1
 jp nz,excln1;weiter bis Breite=0
 pop af ;Zeichenbreite holen
 ret  ;und zurck


winpop:  ;'Popt' ein Fenster hoch
 cp 1 ;1 Parameter
 jp m,opmis
 jp nz,imparg
 ld a,(wincnt);Anz. d. Windows
 ld b,a ;nach B
 ld a,(ix+0);Windownummer nach A
 ld hl,winnum;HL auf Tab. d. W.num.
wpop1: inc hl ;auf nchsten Eintrag
 cp (hl) ;=Windownummer?
 jp z,wpop2 ;ja? dann weiter
 djnz wpop1 ;sonst nochmal versuchen
 jp imparg ;nicht gefunden? Fehler!
wpop2: ld a,(wincnt);Offset des Eintrags
 sub b ;nach BC
 inc a
 ld c,a
 ld b,0
 ld d,0
 ld a,(wincnt);Anz.d.Wind.
 ld e,a ;nach DE
 ld hl,winnum;HL auf Tab. d. Nummern
 add hl,de ;HL auf letzten Eintrag
wpop3: ld a,(hl) ;Nummer des obersten Window
 call wpoph ;Window verstecken
 ld a,e ;Offsets vergleichen
 sub c
 jp z,wpop4 ;gleich? dann weiter
 dec hl ;HL retten
 dec e ;sonst mit nchstem Window
 jp wpop3 ;nochmal
wpop4: ld a,(wincnt);Anz.d.Wind.
 ld e,a ;nach DE
 push bc ;Offset retten
 push hl
wpop5: inc c ;nchstes Window (v. unten)
 inc hl
 ld a,(hl) ;nach A
 call wpops ;und W. wieder einblenden
 ld a,c ;schon oberstes Window?
 sub e
 jp nz,wpop5;sonst nochmal
 pop hl ;HL holen
 ld a,(hl) ;zu poppendes Window nach A
 pop bc ;Offset holen
 call wpops ;zu poppendes W. einblenden
 ld de,winx1;DE auf Xanf-Wert-Leerplatz
 ld hl,winx1
 add hl,bc ;HL auf Xanf-Wert
 ldi  ;Wert kopieren
 inc bc ;und BC restaurieren
 ld de,winx2;Xende kopieren (wie Xanf)
 ld hl,winx2
 add hl,bc
 ldi
 inc bc
 ld de,winy1;Yanf kopieren
 ld hl,winy1
 add hl,bc
 ldi
 inc bc
 ld de,winy2;Yende kopieren
 ld hl,winy2
 add hl,bc
 ldi
 inc bc
 ld de,winnum;Nummer kopieren
 ld hl,winnum
 add hl,bc
 ldi
 inc bc
 ld de,hidden;hidden-Attribut kopieren
 ld hl,hidden
 add hl,bc
 ldi
 inc bc
 ld de,winadr;Adresse kopieren
 ld hl,winadr
 add hl,bc ;16-Bittig, daher 2* add.
 add hl,bc
 ldi  ;und 2* kopieren
 inc bc
 ldi
 inc bc
 ld de,winlan;Lnge kopieren
 ld hl,winlan
 add hl,bc
 add hl,bc
 ldi
 inc bc
 ldi
 inc bc
 ld a,(wincnt);Anz.d.Wind. nach A
 sub c ;-Offset
 ld hl,winx1;Adr. d. X-Werte nach HL
 ld de,winx1;und DE
 add hl,bc ;HL auf nchsten Eintrag
 ex de,hl ;HL und DE tauschen
 add hl,bc ;HL auf nchsten Eintrag
 inc hl ;+1
 push bc ;Zhler retten
 ld c,a ;Anz. d. hheren W. nach BC
 ldir  ;und Tabelle verschieben
 pop bc ;Zhler holen
 ld hl,winx2;mit Xende-Werten wie mit
 ld de,winx2;Xanf
 add hl,bc
 ex de,hl
 add hl,bc
 inc hl
 push bc
 ld c,a
 ldir
 pop bc
 ld hl,winy1;Yanf-Tabelle verschieben
 ld de,winy1
 add hl,bc
 ex de,hl
 add hl,bc
 inc hl
 push bc
 ld c,a
 ldir
 pop bc
 ld hl,winy2;Yende-Tabelle verschieben
 ld de,winy2
 add hl,bc
 ex de,hl
 add hl,bc
 inc hl
 push bc
 ld c,a
 ldir
 pop bc
 ld hl,winnum;Tab. d. Windownummern
 ld de,winnum;verschieben
 add hl,bc
 ex de,hl
 add hl,bc
 inc hl
 push bc
 ld c,a
 ldir
 pop bc
 ld hl,hidden;Hidden-Tab. verschieben
 ld de,hidden;verschieben
 add hl,bc
 ex de,hl
 add hl,bc
 inc hl
 push bc
 ld c,a
 ldir
 pop bc
 ld hl,winadr;Adresstabelle verschieben
 ld de,winadr
 add hl,bc ;Tabelle ist 16-Bit breit,
 add hl,bc ;==> 2 mal addieren,...
 ex de,hl
 add hl,bc
 add hl,bc
 inc hl ;...2 mal erhhen...
 inc hl
 push bc
 ld c,a
 ldir
 ld c,a ;...und 2 mal verschieben
 ldir
 pop bc
 ld hl,winlan;Lngentabelle verschieben
 ld de,winlan
 add hl,bc
 add hl,bc
 ex de,hl
 add hl,bc
 add hl,bc
 inc hl
 inc hl
 ld c,a
 ldir
 ld c,a
 ldir
 ld a,(wincnt);Anz.d.Wind.
 ld c,a ;nach BC
 ld de,winx1;HL und DE auf Xanf
 ld hl,winx1
 add hl,bc ;HL auf neuen Platz
 ex de,hl ;HL und DE tauschen
 ldi  ;Xanf kopieren
 inc bc ;und BC restaurieren
 ld de,winx2;Xende kopieren (wie Xanf)
 ld hl,winx2
 add hl,bc
 ex de,hl
 ldi
 inc bc
 ld de,winy1;Yanf kopieren
 ld hl,winy1
 add hl,bc
 ex de,hl
 ldi
 inc bc
 ld de,winy2;Yende kopieren
 ld hl,winy2
 add hl,bc
 ex de,hl
 ldi
 inc bc
 ld de,winnum;Nummer kopieren
 ld hl,winnum
 add hl,bc
 ex de,hl
 ldi
 inc bc
 ld de,hidden;Attribut kopieren
 ld hl,hidden
 add hl,bc
 ex de,hl
 ldi
 inc bc
 ld de,winadr;Adresse kopieren
 ld hl,winadr
 add hl,bc ;16-Bittig, deshalb 2* add.
 add hl,bc
 ex de,hl
 ldi  ;und 2* kopieren
 inc bc
 ldi
 inc bc
 ld de,winlan;Lnge kopieren
 ld hl,winlan
 add hl,bc
 add hl,bc
 ex de,hl
 ldi
 inc bc
 ldi
 ret  ;Fertig!

wpoph: push bc ;Register retten
 push hl
 push de
 push af
 ld hl,hidden;HL auf Attribute
 add hl,de ;Attribut
 ld a,(hl) ;nach B
 ld b,a
 pop af ;Windownummer holen
 push bc ;Attribut retten
 ld ix,ubgbuf;IX auf Buffer
 ld (ix+0),a;Nummer in Buffer
 ld a,1 ;1 Parameter
 call whide ;Window verstecken
 pop bc ;Attribut holen
 ld a,b ;und nach A
 pop de ;Offset holen
 ld hl,hidden;HL auf Attribut
 add hl,de
 ld (hl),a ;und altes Attr. setzen
 pop hl ;Register holen
 pop bc
 ret  ;und zurck

wpops: push bc ;Register retten
 push hl
 push de
 push af
 ld hl,hidden;HL auf Attribut
 add hl,de
 ld a,(hl) ;Attribut nach A
 or a ;=0?
 jp nz,wpopse;sonst nicht darstellen
 ld a,#ff ;Attribut setzen
 ld (hl),a
 pop af ;Nummer holen
 ld ix,ubgbuf;IX auf Buffer
 ld (ix+0),a;Nummer in Buffer
 ld a,1 ;1 Parameter
 call wshow ;Window einblenden
wpopse:pop de ;Register holen
 pop hl
 pop bc
 ret  ;und zurck



 ;Diese Zeilen mssen in MEMFRE vor MEMFR3
 ;eingefgt werden

 ld hl,winadr;Windowadr.tab. nach HL
 inc hl ;HL auf ersten Eintrag
 inc hl
 ld a,(wincnt);Windowzhler nach A
 ld iy,winlan;W-lngentab. nach IY
 inc iy ;IY auf ersten Eintrag
 inc iy
memfr2:ld c,(hl) ;Windowadr. nach BC
 inc hl
 ld b,(hl)
 inc hl
 push hl ;Windowadr.tab. retten
 ld l,(iy+0);Windowlnge nach HL
 inc iy
 ld h,(iy+0)
 inc iy
 add hl,bc ;Adr. hinter Window nach HL
 sbc hl,de ;=Adr. des Bereichs?
 pop hl ;    Adr. der Tabelle holen
 jp z,pushwd;wenn =:Window hochkopieren
 dec a ;sonst nchstes Window
 jp nz,memfr2



 ;Das hier gehrt auch noch zu MEMFRE, wird
 ;aber als Unterprogramm aufgerufen

pushwd:  ;kopiert ein Window 'hoch'
 push hl ;Adresstabelle retten
 dec iy ;Windowlnge nach BC
 ld b,(iy+0)
 dec iy
 ld c,(iy+0)
 ld de,(wadr);Bereichsadr. nach HL
 ld hl,(wlaeng);Bereichslnge nach BC
 add hl,de ;Zeiger hinter Bereichsende
 dec hl ;Zeiger auf Bereichsende
 dec de ;DE auf Window
 ex de,hl ;DE und HL tauschen
 lddr  ;Window kopieren
 inc de ;DE auf neue Windowadr.
 inc hl ;HL auf neue Bereichsadr.
 ld (wadr),hl;Bereichsadr. eintragen
 pop hl ;Adresstabelle holen
 dec hl ;neue Windowadr. eintragen
 ld (hl),d
 dec hl
 ld (hl),e
 jp memfr0 ;und nochmal testen


