 ;Eintrge in 'rsx'-Sprungtabelle
 jp menu
 jp albox
 jp gettme
 jp puttme
 jp quit

;Eintrge in 'table' der RSX-Befehle
 defm "MEN"
 defb "U"+#80
 defm "ALERTBO"
 defb "X"+#80
 defm "GETTIM"
 defb "E"+#80
 defm "PUTTIM"
 defb "E"+#80
 defm "QUI"
 defb "T"+#80

;Ass.listing der Befehlsroutinen
menu:          ;stellt ein Menue dar
 cp 4                  ;4 Parameter?
 jp m,opmis         ;weniger? Fehler
 push af       ;Parameterzahl retten
 dec a                 ;Parameter -3
 dec a
 dec a
 push ix           ;Parameter retten
 ld b,a        ;Parameterzahl nach B
 ld c,0               ;Breite nach C
menu1: ld l,(ix+0)      ;Adresse des
                    ;letzten Strings
 ld h,(ix+1)                ;nach HL
 ld a,(hl) ;Lnge des Strings nach A
 cp c            ;grer als Breite?
 jp m,menu2       ;nein? dann weiter
 ld c,a           ;sonst neue Breite
menu2: inc ix  ;IX auf nchsten Str.
 inc ix
 djnz menu1 ;Weiter bis alle Strings
 ld a,c               ;Breite nach A
 ld (mlen),a          ;und eintragen
 pop iy             ;Parameter holen
 pop af         ;Parameterzahl holen
 push ix           ;Parameter retten
 push af       ;Parameterzahl retten
 ld ix,ubgbuf         ;IX auf Buffer
 call #bb69          ;TXT GET WINDOW
 pop af         ;Parameterzahl holen
 push hl        ;Windowkoords retten
 push de
 push iy           ;Parameter retten
 push af       ;Parameterzahl retten
 dec a             ;Parameterzahl -2
 dec a
menu3: inc iy  ;Zeiger auf n. Param.
 inc iy
 dec a             ;Parameterzahl -1
 jp nz,menu3 ;schon 0? sonst nochmal
 ld a,(iy+0)           ;Y-Wert holen
 ld (ix+4),a;und als 3.Param. setzen
 ld b,a               ;Y-Wert nach B
 ld (myanf),a   ;und als Anfangswert
 pop af         ;Parameterzahl holen
 push af       ;Parameterzahl retten
 dec a           ;Anzahl der Strings
 dec a
 dec a
 dec a
 add a,b                ;+Yanf=Yende
 ld (ix+0),a  ;5.Parameter eintragen
 ld a,(iy+2)           ;X-Wert holen
 ld (mxanf),a  ;eintragen (als Xanf)
 ld (ix+6),a   ;und als 2. Parameter
 add a,c          ;Yanf+Breite=Yende
 ld (ix+2),a        ;Als 4.Parameter
 xor a               ;Windownummer 0
 ld (ix+8),a        ;als 1.Parameter
 ld a,5                 ;5 Parameter
 push ix     ;Parameterzeiger retten
 call wopen           ;Window ffnen
 pop ix       ;Parameterzeiger holen
menu4: 
 pop af         ;Parameterzahl holen
 pop iy     ;bergabeparameterzhler
 dec a             ;Parameterzahl -3
 dec a
 dec a
 ld (manz),a;als Menpunktzahl eint.
 ld c,a   ;und Menpunktzahl nach BC
 ld b,0
 jp menu6         ;CRLF berspringen
menu5:
 push bc              ;Zhler retten
 call #bb93             ;TXT GET PEN
 push af                 ;PEN retten
 ld a,1                       ;PEN 1
 call #bb90                  ;setzen
 ld hl,crlf            ;CRLF nach HL
 ld a,2                   ;2 Zeichen
 call print           ;CRLF ausgeben
 pop af             ;alten Pen holen
 call #bb90              ;und setzen
 pop bc         ;Zhler wieder holen
menu6: push iy  ;Param.zhler retten
 add iy,bc  ;Zeiger auf ersten Param
 add iy,bc
 dec iy
 dec iy
 ld l,(iy+0)    ;HL auf Stringdeskr.
 ld h,(iy+1)
 ld a,(hl)       ;Stringlnge nach A
 inc hl           ;HL auf Stringadr.
 push bc              ;Zhler retten
 call print         ;String ausgeben
 pop bc                ;Zhler holen
 pop iy         ;Zeiger wieder holen
 dec c                    ;Zhler -1
 jp nz,menu5           ;weiter bis 0
 xor a   ;Menpunktflag zurcksetzen
 ld (mpoint),a
 call #bc1a       ;SCR CHAR POSITION
 ld a,b        ;Zeichenbreite nach A
 cp 4                       ;Mode 0?
 jp nz,menu7           ;sonst weiter
 dec a                  ;Exponent -1
menu7: ld (zbr),a   ;Exponent setzen
 call mint          ;Event einhngen
 call cursor ;Cursorabfrage aufrufen
 call mdel          ;Event aushngen
 call wclose       ;Window schlieen
 pop de     ;alte Windowkoords holen
 pop hl
 call #bb66          ;TXT WIN ENABLE
 pop ix       ;Parameterzhler holen
 ld a,(mpoint)  ;Menpunktflag holen
 ld l,(ix+0) ;Parameteradresse holen
 ld h,(ix+1)                ;(men%)
 ld (hl),a   ;Param.flag zurckgeben
 ret                    ;und fertig!

mpoint:defs 1
mlen: defs 1
manz: defs 1
mxanf: defs 1
myanf: defs 1
mxend: defs 1
zbr: defs 1
mbuff: defs 6
mbuff1:defs 7

crlf: defw crlf1    ;Zeiger auf CRLF
crlf1: defb #0D,#0A            ;CRLF

mint:          ;Men-Event einhngen
 ld hl,mbuff1  ;Event-Buffer nach HL
 ld b,131        ;Event-Class nach B
 ld de,mcurs   ;Eventroutine nach DE
 call #bcef           ;KL INIT EVENT
 ld bc,2     ;Laufzeit und Startwert
 ld de,2             ;nach HL und DE
 ld hl,mbuff     ;HL auf Eventbuffer
 call #bce9           ;KL ADD TICKER
 ei             ;Interrupts zulassen
 jp #bd07           ;KL EVENT ENABLE
 
mdel:          ;Men-Event aushngen
 ld hl,mbuff   ;Event-Buffer nach HL
 jp #bcec             ;KL DEL TICKER

mcurs: nop;Interruptroutine fr MENU
 ld hl,(v1)          ;X-Wert nach HL
 srl h                     ;X-Wert4
 rr l
 srl h
 rr l
 ld a,(zbr)         ;Exponent nach B
 ld b,a
mcur2: srl l               ;X-Wert2
 djnz mcur2   ;weiter bis Exponent 0
 inc l                     ;X-Wert+1
 push hl              ;X-Wert nach C
 pop bc
 ld de,(v2)          ;Y-Wert nach DE
 ld hl,399             ;Ymax nach HL
 sbc hl,de                 ;Y=Ymax-Y
 srl h                    ;Y-Wert16
 rr l
 srl l
 srl l
 srl l
 inc l                           ;+1
 ld a,(mxanf)           ;Xanf nach B
 ld b,a
 ld a,c                 ;Xpos nach A
 sub b                        ;-Xanf
 jp m,mcext  ;Xpos<Xanf? dann zurck
 ld b,a            ;Xpos-Xanf nach B
 ld a,(mlen)          ;Breite nach A
 cp b                  ;<=Xpos-Xanf?
 jp m,mcext             ;dann zurck
 ld a,(myanf)           ;Yanf nach B
 ld b,a
 ld a,l                 ;Ypos nach A
 sub b                        ;-Yanf
 jp m,mcext  ;Ypos<Yanf? dann zurck
 ld b,a            ;Ypos-Yanf nach B
 ld a,(manz)          ;Anzahl nach A
 dec a                       ;und -1
 cp b                  ;<=Ypos-Yanf?
 jp m,mcext             ;dann zurck
 ld a,b   ;sonst Ypos-Yanf=Nummer...
 inc a        ;...des Menpunktes -1
 ld hl,mpoint      ;HL auf Menpunkt
 cp (hl)                    ;gleich?
 ret z                  ;dann zurck
 push af   ;sonst neuen Punkt retten
 ld a,(mpoint)   ;alten Punkt nach A
 call #bd19       ;MC WAIT FRAME FLY
 or a               ;alter Punkt =0?
 call nz,invlne   ;Balken ausblenden
 pop af           ;neuen Punkt holen
 ld (mpoint),a     ;Nummer eintragen
invlne:ld l,a          ;Zeile nach L
 dec l                     ;Zeile -1
 ld a,(myanf)         ;Anfang nach A
 add a,l         ;Anfang des Windows
 ld l,a                      ;nach l
 dec l                       ;und -1
 ld a,(mxanf)    ;Spalte=Xanf nach H
 ld h,a
 dec h                       ;Xanf-1
 ld a,(mlen)          ;Breite nach A
 inc a ;+1
 ld b,#ff    ;Farben zum Invertieren
 ld c,0                ;nach B und C
invln1:push hl        ;Koords retten
 push bc              ;Farben retten
 push af       ;brige Breite retten
 call #bc4a         ;SCR CHAR INVERT
 pop af                ;Breite holen
 pop bc                ;Farben holen
 pop hl                ;Koords holen
 inc h                    ;Spalte +1
 dec a                    ;Breite -1
 jp nz,invln1   ;weiter bis Spalte=0
 ret                     ;und zurck

mcext: ld a,(mpoint);Menpunkt holen
 or a                           ;=0?
 call nz,invlne   ;Balken ausblenden
 xor a               ;kein Menpunkt
 ld (mpoint),a               ;setzen
 ret                     ;und zurck


albox:       ;erstellt eine Alertbox
 cp 4                  ;4 Parameter?
 jp m,opmis        ;weniger? Fehler!
 cp 10        ;Mehr als 9 Parameter?
 jp p,imparg                 ;Fehler
 dec a              ;Parameterzahl-3
 dec a                  ;=Zeilenzahl
 dec a
 push af                     ;retten
 call #bc17         ;SCR CHAR LIMITS
 inc b              ;Rechter Rand +1
 srl b             ;und halbe Breite
 pop af            ;Zeilenzahl holen
 push af          ;und wieder retten
 ld c,b         ;halbe Breite nach C
 ld b,a           ;Zeilenzahl nach B
albox1:ld l,(ix+0) ;Stringdeskr.  HL
 ld h,(ix+1)
 ld a,(hl)       ;Stringlnge nach A
 dec a                           ;-1
 cp c              ;>= halbe Breite?
 jp p,imparg            ;dann Fehler
 inc ix   ;sonst auf nchsten String
 inc ix         
 djnz albox1  ;bis alle Zeilen durch
 pop af            ;Zeilenzahl holen
 push af          ;und wieder retten
 push ix           ;Parameter retten
 ld ix,ubgbuf  ;bergabebuffer nach X
 ld b,c         ;halbe Breite nach B
 srl b                  ;und durch 2
 inc b                       ;und +1
 ld (ix+6),b                  ;=Xanf
 ld d,a           ;Zeilenzahl nach D
 ld a,c               ;Breite nach A
 add a,b               ;Breite +Xanf
 dec a                           ;-1
 ld (ix+2),a                 ;=Xende
 ld (ix+0),16              ;Yende=16
 ld a,11                    ;Yanf=11
 sub d                  ;-Zeilenzahl
 ld (ix+4),a              ;eintragen
 call #bb69          ;TXT GET WINDOW
 pop iy             ;Stack aufrumen
 pop af
 push hl
 push de        ;Windowkoords retten
 push af  ;und Stack wieder aufbauen
 push iy
 xor a                ;Windownumer 0
 ld (ix+8),a              ;eintragen
 ld a,5                 ;5 Parameter
 push bc        ;halbe Breite retten
 call wopen          ;Fenster ffnen
 pop bc          ;halbe Breite holen
 pop iy            ;Parameter  holen
 pop af          ;Zeilenzhler holen
 ld b,a         ;Zeilenzhler nach B
 push iy           ;Parameter retten
albox2:push bc            ;BC retten
 dec iy  ;Zeiger auf nchsten String
 dec iy
 call #bb93             ;TXT GET PEN
 push af                 ;Pen retten
 ld a,1                       ;Pen 1
 call #bb90                  ;setzen
 ld hl,crlf                    ;CRLF
 ld a,2
 call print                ;ausgeben
 ld l,(iy+0)   ;Stringdeskr. nach HL
 ld h,(iy+1)
 ld a,c         ;halbe Breite nach A
 sub (hl)              ;-Stringlnge
 srl a                        ;/2...
 ld b,32          ;...Leerzeichen...
 or a                      ;0 Stck?
 call nz,chars    ;sonst ...ausgeben
 ld a,(hl)       ;Stringlnge nach A
 inc hl               ;HL auf String
 call print     ;und String ausgeben
 pop af                   ;PEN holen
 call #bb90       ;und wieder setzen
 pop bc                    ;BC holen
 djnz albox2 ;und weiter alle Zeilen
 pop iy             ;Parameter holen
 inc iy  ;Rckgabeparam.berspringen
 inc iy
 ld ix,ubgbuf ;IX auf bergabebuffer
 ld a,(iy+2)    ;1. Iconnummer holen
 ld (ix+0),a          ;und eintragen
 ld (ix+2),207                ;Y=207
 ld (ix+3),0
 ld (ix+4),240                ;X=240
 ld (ix+5),0
 ld a,3                 ;3 Parameter
 call icon       ;1. Icon darstellen
 ld ix,ubgbuf;bergabebuffer nach IX
 ld a,(iy+0)           ;2.Iconnummer
 ld (ix+0),a              ;eintragen
 ld (ix+2),207                ;Y=207
 ld (ix+4),96                 ;X=352
 ld (ix+5),1
 ld a,3                 ;3 Parameter
 call icon       ;2. Icon darstellen
 ld ix,ubgbuf ;IX auf bergabebuffer
albox3:ld a,1           ;1 Parameter
 call getic           ;Icon abfragen
 ld a,(ix+0)            ;Icon nach A
 cp (iy+0)                ;=2. Icon?
 jp z,albox4            ;dann weiter
 cp (iy+2)           ;sonst: 1.Icon?
 jp nz,albox3    ;nein? dann nochmal
albox4:dec iy ;IY auf Rckgabeparam.
 dec iy
 ld l,(iy)    ;Parameteradr. nach HL
 ld h,(iy+1)
 ld (hl),a    ;und Iconnr. eintragen
 ld a,(maxmen);Anz.der dargest.Icons
 dec a                           ;-2
 dec a
 ld (maxmen),a            ;eintragen
 pop de     ;Windowkoordinaten holen
 pop hl
 call #bb66          ;TXT WIN ENABLE
 jp wclose     ;und Window schlieen

  
int:        ;hngt den Event fr die
                            ;Uhr ein
 ld hl,buff1;HL a. Eventblock-Buffer
 ld b,131           ;Eventtyp nach B
 ld de,clock    ;DE auf Eventroutine
 call #bcef           ;KL INIT EVENT
 ld hl,buffer    ;HL auf Eventbuffer
 ld bc,50      ;Startverzgerung und
 ld de,50       ;Laufzeit auf 1 Sek.
 call #bce9           ;KL ADD TICKER
 ei             ;Interrupts zulassen
 call #bd07         ;KL EVENT ENABLE
 ret                    ;und zurck.
buffer:defs 6
buff1: defs 7
clock: ld hl,time       ;HL auf Zeit
 ld a,(hl)          ;2. Sekundenbyte
 inc a                      ;erhhen
 ld (hl),a      ;und zurchschreiben
 cp 10                         ;=10?
 ret nz           ;nein? dann Fertig
 xor a        ;sonst 2. Sekundenbyte
 ld (hl),a                ;=0 setzen
 inc hl             ;1. Sekundenbyte
 ld a,(hl)                   ;nach A
 inc a                           ;+1
 ld (hl),a
 cp 6                           ;>5?
 ret nz
 xor a
 ld (hl),a
 inc hl              ;2. Minutenbyte
 ld a,(hl)
 inc a
 ld (hl),a
 cp 10                           ;>9
 ret nz
 xor a
 ld (hl),a
 inc hl               ;1.Minutenbyte
 ld a,(hl)
 inc a
 ld (hl),a
 cp 6                           ;>5?
 ret nz
 xor a
 ld (hl),a
 inc hl              ;2. Stundenbyte
 ld a,(hl)
 inc a
 ld (hl),a
 cp 4                          ;<>4?
 jp nz,clo2             ;dann weiter
 inc hl    ;sonst erstes Stundenbyte
 ld a,2                         ;=2?
 cp (hl)
 jp nz,clot       ;nein? Stunden OK.
 xor a                  ;sonst 0 Uhr
 ld (hl),a                ;eintragen
 dec hl       ;in beide Stundenbytes
 ld (hl),a
 ret                     ;und Fertig
clo2: cp 10       ;2. Stundenbyte>9?
 ret nz
 xor a
 ld (hl),a
 inc hl              ;1. Stundenbyte
 ld a,(hl)
 inc a                           ;+1
 ld (hl),a
 ret                     ;und Fertig
clot: dec hl  ;HL auf 2. Stundenbyte
 ld a,(hl)                   ;nach A
 jp clo2                 ;und weiter
time: defs 6

quit:                  ;Quit-Routine
 call #bcc8            ;KL CHOKE OFF
 ld de,#0040         ;Beginn des RAM
 ld hl,#abff           ;Ende des RAM
 jp #bccb               ;KL ROM WALK

gettme:        ;gibt die Zeit zurck
 cp 1                  ;1 Parameter?
 jp m,opmis
 jp nz,imparg
 ld l,(ix+0);Parameterstring nach HL
 ld h,(ix+1)
 ld a,(hl)                    ;Lnge
 ld (hl),8    ;=8 Zeichen (HH:MM:SS)
 cp 8                ;war schon >=8?
 jp p,gettm3            ;dann weiter
 push hl    ;sonst Deskriptor retten
 ld a,8                ;8 Byte Platz
 rst #18         ;vom Betriebssystem
 defw getstr              ;anfordern
 pop hl                ;Deskr. holen
 inc hl              ;HL auf Adresse
 ld (hl),e          ;neue Stringadr.
 inc hl                   ;eintragen
 ld (hl),d
gettm0:ld hl,time       ;HL auf Zeit
 ld bc,5
 add hl,bc     ;und auf erste Ziffer
 ld b,2           ;2 mal wiederholen
gtme2: ld c,2             ;2 Ziffern
gtme1: ld a,(hl)       ;Ziffer holen
 add a,48  ;in ASCII-Zeichen wandeln
 ld (de),a  ;und in String eintragen
 inc de     ;DE auf nchstes Zeichen
 dec hl       ;HL auf nchste Ziffer
 dec c                          ;c-1
 jp nz,gtme1      ;=0? sonst nochmal
 ld a,58                        ;':'
 ld (de),a                ;eintragen
 inc de     ;DE auf nchstes Zeichen
 djnz gtme2           ;alles nochmal
 ld a,(hl)          ;Sekunden holen,
 add a,48                  ;wandeln,
 ld (de),a            ;und eintragen
 inc de
 dec hl
 ld a,(hl)
 add a,48
 ld (de),a
 ret                        ;fertig!
gettm3:inc hl     ;HL auf Stringadr.
 ld e,(HL)        ;Stringadr nach DE
 inc hl
 ld d,(hl)
 jp gettm0               ;und weiter
getstr:defw #fc41 ;464:fc19 664:fc41
 defb #fd   ;Reserv. A Byte f.String

puttme:              ;stellt die Uhr
 cp 1                  ;1 Parameter?
 jp m,opmis
 jp nz,imparg
 ld l,(ix+0)   ;Stringdeskr. nach HL
 ld h,(ix+1)
 ld a,(hl)              ;Stringlnge
 cp 8 ;=8?
 jp nz,imparg          ;sonst Fehler
 inc hl           ;HL auf Stringadr.
 ld e,(hl)       ;Stringadr. nach DE
 inc hl
 ld d,(hl)
 dec de               ;DE vor String
 ld hl,time             ;HL auf Zeit
 ld bc,5
 add hl,bc      ;HL auf erste Ziffer
 ld b,3               ;3 mal (H,M,S)
puttm1:ld c,2             ;2 Ziffern
 inc de      ;1 Zeichen berspringen
puttm2:ld a,(de)       ;Ziffer holen
 sub 48      ;in Dezimalzahl wandeln
 jp m,imparg    ;<0? dann keine Zahl
 cp 10                          ;>9?
 jp p,imparg   ;dann auch keine Zahl
 ld (hl),a         ;Ziffer eintragen
 dec hl              ;nchste Ziffer
 inc de            ;nchstes Zeichen
 dec c                    ;Zhler -1
 jp nz,puttm2     ;=0? sonst nochmal
 djnz puttm1    ;nochmal (fr H,M,S)
 ret                        ;Fertig!

 ;Nach PUTCUR muss vor ld a,(smode)
 ;eingefgt werden:
 ld a,#c9               ;RET in Akku
 ld (mcurs),a     ;und MCURS sperren

 ;Nach PUTCU0 muss nach ld (smode),a
 ;eingefgt werden:
 xor a                   ;NOP nach A
 ld (mcurs),a   ;und MCURS freigeben

 ;In MPATCH mu der 'RET'-Befehl
 ;ersetzt werden durch:
 jp int

